import { ElementRef, EventEmitter, OnChanges, OnInit, QueryList, TemplateRef } from '@angular/core';
export declare class DrsNavbarComponent implements OnInit, OnChanges {
    constructor();
    /**
     * Main links custom template
     */
    linkTemplate: TemplateRef<DrsNavbarLinks>;
    /**
     * How the records in dropdown lists are shown
     */
    dropdownTemplate: TemplateRef<DrsNavbarDropdown>;
    /**
     * Custom content in the button section when the navbar is open and close.
     *
     * **The button is shown only in mobile version**
     */
    buttonTemplate?: ButtonTemplate;
    /**
     * {@link DrsNavbarConfiguration DrsNavbarConfiguration} configuration
     */
    navbarConfiguration: DrsNavbarConfiguration;
    navbar: ElementRef<HTMLElement>;
    links: QueryList<any>;
    dropDownShowing: number;
    paletteClass: string;
    isOpen: boolean;
    onDropdownClick: EventEmitter<string>;
    onDropDownLinkClick: EventEmitter<string>;
    ngOnInit(): void;
    ngOnChanges(): void;
    clickout(event: any): void;
    navbarChanges(event: any): void;
    toggleNavOnButtonClick(): void;
    closeNvb(): void;
    initializeConfiguration(): void;
    showDesktopDropdown(key: number): void;
    showPhoneDropdown(key: number): void;
    clearDropdown(): void;
    /** Link emitter */
    emitLinkClick(name: string): void;
    /** Dropdown emitter */
    emitDropdownClick(type: string): void;
}
export declare class DrsNavbarConfiguration {
    links: DrsNavbarLinks[];
    palette?: DrsNavbarPalette;
    logoSrc?: string;
}
export declare class DrsNavbarLinks {
    name: string;
    route: string;
    dropDownList?: DrsNavbarDropdown[];
    custom?: any;
}
export declare class DrsNavbarDropdown {
    name: string;
    key: any;
    custom?: any;
}
export declare class ButtonTemplate {
    openedDropdown: TemplateRef<any>;
    closedDropdown: TemplateRef<any>;
}
export declare enum DrsNavbarPalette {
    DarkPalette = "dark-palette",
    RedPalette = "red-palette",
    VioletPalette = "violet-palette",
    GreenPalette = "green-palette",
    SkyPalette = "sky-palette",
    OrangePalette = "orange-palette"
}
